## gtk4 4.6.9+ds

=== meson_options.txt ===
# GDK backends

option('x11-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the X11 gdk backend (only when building on Unix)')

option('wayland-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the wayland gdk backend (only when building on Unix except for macOS)')

option('broadway-backend',
       type: 'boolean',
       value: false,
       description : 'Enable the broadway (HTML5) gdk backend')

option('win32-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the Windows gdk backend (only when building on Windows)')

option('macos-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the macOS gdk backend (only when building on macOS)')

# Media backends
# For distros: GTK guarantees support for WebM video (VP8 and VP9), so a supported build
# should provide that.

option('media-ffmpeg',
       type: 'feature',
       value: 'disabled',
       description : 'Build the experimental ffmpeg media backend')

option('media-gstreamer',
       type: 'feature',
       value: 'enabled',
       description : 'Build the gstreamer media backend')

# Print backends

option('print-cups',
       type: 'feature',
       value: 'auto',
       description : 'Build the cups print backend')

# Optional features

option('vulkan',
       type: 'feature',
       value: 'disabled',
       description : 'Enable support for the experimental Vulkan graphics API')

option('cloudproviders',
       type: 'feature',
       value: 'disabled',
       description : 'Enable the cloudproviders support')

option('sysprof',
       type: 'feature',
       value: 'disabled',
       description : 'include tracing support for sysprof')

option('tracker',
       type: 'feature',
       value: 'disabled',
       description : 'Enable Tracker3 filechooser search')

option('colord',
       type: 'feature',
       value: 'disabled',
       description : 'Build colord support for the CUPS printing backend')

option('f16c',
       type: 'feature',
       value: 'enabled',
       description: 'Enable F16C fast paths (requires F16C)')

# Documentation and introspection

option('gtk_doc',
       type: 'boolean',
       value: false,
       description : 'Build API reference and tools documentation')

option('man-pages',
       type: 'boolean',
       value: false,
       description : 'Build man pages for installed tools')

option('introspection',
       type: 'feature',
       value: 'auto',
       yield: true,
       description : 'Build introspection data (requires gobject-introspection)')

# Demos, examples and tests

option('demos',
       type: 'boolean',
       value: true,
       description : 'Build demo programs')

option('profile',
       type: 'combo',
       choices: [ 'default', 'devel' ],
       value: 'default',
       description : 'Profile to use for demos')

option('build-examples',
       type: 'boolean',
       value: true,
       description : 'Build examples')

option('build-tests',
       type: 'boolean',
       value: true,
       description : 'Build tests')

option('install-tests',
       type: 'boolean',
       value: false,
       description : 'Install tests')

## gtk4 4.0.3

=== debian/changelog ===
gtk4 (4.0.3-4) experimental; urgency=medium

  * d/log-reftests.py: Collect more test results
  * d/rules: Don't export build results for tests that upstream expect
    to fail
  * d/rules: Update comments regarding failing tests that need to be
    processed

 -- Simon McVittie <smcv@debian.org>  Mon, 22 Feb 2021 10:56:12 +0000

gtk4 (4.0.3-3) experimental; urgency=medium

  * d/patches: Adjust forwarding URL for refactoring
  * d/patches: Never mark rendering differences as accepted, only tolerated.
    Upstream consider absolutely any difference in rendering to be an error,
    so we should always record the diff for inspection.
  * Force installation of fontconfig's preferred fonts for tests.
    The experimental dependency resolver is non-deterministic and can
    choose various different fonts, some of which make the reftests fail.
    Force its hand by choosing the fonts that fontconfig prioritizes highest,
    so that we get deterministic results.
  * d/patches: Fix error reporting in gsk reftests.
    The gsk reftests don't use the GTest framework, so g_test_fail will have
    no effect here.

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Feb 2021 10:46:01 +0000

gtk4 (4.0.3-2) experimental; urgency=medium

  * Tolerate minor differences in some reftests
  * d/rules: Show the detailed test log even if tests all succeed
  * d/rules: Dump reftest differences into the log as base64.
    Debian package builds don't have an equivalent of $AUTOPKGTEST_ARTIFACTS
    (as requested in https://bugs.launchpad.net/launchpad/+bug/1845159) so
    this is the best we can do right now.

 -- Simon McVittie <smcv@debian.org>  Sun, 14 Feb 2021 14:28:39 +0000

gtk4 (4.0.3-1) experimental; urgency=medium

  * New upstream release
  * symbols: Ignore removal of gtk_glade_catalog_init.
    This symbol appeared in the ABI, but not in any header files, and is
    considered private.
  * d/rules: Show test log if build-time test fails.
    dh_auto_test would automatically show meson-logs/testlog.txt, but
    because we're running with --setup=x11, we get
    meson-logs/testlog-x11.txt instead.
  * Increase dependency on librsvg2-common from Suggests to Recommends.
    This is not a hard dependency, but should be installed in nearly all
    cases. Increasingly many icons are provided in SVG format, so
    applications will appear broken if the SVG pixbuf loader is not
    installed. See #980396 for more information.
    adwaita-icon-theme already Recommends librsvg2-common, but people who
    routinely do not install recommended packages will get a better hint
    about how much will be broken by its removal if GTK also recommends it.
  * Bump graphene build-dependency to 1.10.4 on i386.
    Earlier versions used SSE, which has stricter alignment requirements
    that cause many of the build-time tests to fail (in addition to not
    being available on Debian's baseline CPU).
  * d/rules: Add a note of the test failures that need investigation
  * d/rules: Extend test timeout on slower architectures
  * Add myself to Uploaders

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Feb 2021 10:05:16 +0000

gtk4 (4.0.1-1) experimental; urgency=medium

  * Team upload
  * New upstream release
  * d/rules: Force recompilation of CSS with sassc

 -- Simon McVittie <smcv@debian.org>  Tue, 12 Jan 2021 18:45:15 +0000

gtk4 (4.0.0-1) experimental; urgency=medium

  * Team upload
  * New upstream release
    - Bump SONAME to libgtk-4.so.1 to reflect incompatibility with 3.9x.y
      development releases
  * Rename source package to gtk4 while we're going through NEW anyway.
    This reflects the upstream name of the library (formerly GTK+,
    now GTK) and avoids "+" being misinterpreted as a space in URLs.
  * Bump required version for all symbols to 4.0.0
  * Add Provides for gir1.2-gdkwayland-4.0 on Linux
  * d/copyright: Remove unused GPL-2+ paragraph
  * d/copyright: Remove unused autoconf-archive paragraph
  * Standards-Version: 4.5.1 (no changes required)
  * Add a Lintian override for #970275
  * d/tests: Reduce number of tests marked as flaky
  * Add iso-codes as a Recommends, and depend on it for tests
  * Disable gvfs and other GIO modules for build-time tests.
    If running on a developer system, we don't want to interact with
    "larger" components like gnome-online-accounts.
  * Make build-time test failures fatal
  * Add missing libxdamage-dev (build-)dependency
  * Preferentially build-depend on libgdk-pixbuf-2.0-dev.
    We don't need the deprecated Xlib integration that is also pulled in
    by the older libgdk-pixbuf2.0-dev package (see #974870).
  * d/changelog: Remove trailing whitespace
  * Replace XC-Package-Type with Package-Type
  * Use https for Homepage
  * d/watch: ".." is not a version number
  * Bump build-dependency on Glib to 2.66
  * Split gtk-4-tests into its own package
  * libgtk-4-1 Breaks/Replaces experimental libgtk-4-0.
    Both packages contain the print backends, which do not contain the
    SONAME in their names. We anticipate that if the SONAME was bumped in
    future, the "4.0.0" in the module loading path would also change, so
    this isn't a problem for Policy §8.2; the only reason the path didn't
    already change here is that versions prior to 4.0.0 were development
    snapshots and explicitly not API- or ABI-stable.
    Moving the print backends to a separate package would create a circular
    dependency (since libgtk-4-1 would need at least a Recommends on the
    print backends, and the print backends depend on the main library),
    and would not actually help co-installability with a future libgtk-4-2,
    since they should be upgraded in lockstep.
  * Remove obsolete Breaks copied from GTK 3

 -- Simon McVittie <smcv@debian.org>  Sun, 27 Dec 2020 00:23:58 +0000

gtk+4.0 (3.99.4-1) experimental; urgency=medium

  * Team upload
  * New upstream release
  * Build with system copy of gtk-doc
    - d/gbp.conf: Stop adding gtk-doc as a second orig tarball


=== debian/control ===
Source: gtk4
Section: libs
Priority: optional
Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>, 
Build-Depends: adwaita-icon-theme <!nocheck>,
               at-spi2-core <!nocheck>,
               dbus <!nocheck>,
               debhelper-compat (= 13),
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               fonts-cantarell <!nocheck>,
               fonts-dejavu-core <!nocheck>,
               gnome-pkg-tools (>= 0.11),
               gobject-introspection (>= 1.41.3),
               gsettings-desktop-schemas <!nocheck>,
               iso-codes <!nocheck>,
               libcairo2-dev (>= 1.14.0),
               libcolord-dev (>= 0.1.9),
               libcups2-dev (>= 2.0),
               libegl1-mesa-dev [linux-any],
               libepoxy-dev,
               libfontconfig1-dev,
               libfribidi-dev (>= 0.19.7),
               libgdk-pixbuf-2.0-dev (>= 2.30.0) | libgdk-pixbuf2.0-dev (>= 2.30.0),
               libgirepository1.0-dev (>= 1.39.0),
               libglib2.0-dev (>= 2.66.0),
               libgraphene-1.0-dev (>= 1.9.1),
               libgraphene-1.0-dev (>= 1.10.4~) [any-i386],
               libharfbuzz-dev (>= 0.9),
               libjson-glib-dev,
               libpango1.0-dev (>= 1.47.0),
               librest-dev,
               librsvg2-common <!nocheck>,
               librsvg2-dev,
               libvulkan-dev [linux-any],
               libwayland-dev (>= 1.14.91) [linux-any],
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxinerama-dev,
               libxkbcommon-dev (>= 0.2.0),
               libxkbfile-dev,
               libxml2-utils,
               libxrandr-dev (>= 2:1.5.0),
               locales <!nocheck> | locales-all <!nocheck>,
               meson (>= 0.54),
               pkg-config,
               sassc,
               ttf-bitstream-vera <!nocheck>,
               wayland-protocols (>= 1.20) [linux-any],
               xauth <!nocheck>,
               xsltproc,
               xvfb <!nocheck>
Build-Depends-Indep: gtk-doc-tools (>= 1.33),
                     libcairo2-doc,
                     libglib2.0-doc,
                     libpango1.0-doc,
                     pandoc,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4
Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git
Homepage: https://www.gtk.org/

Package: libgtk-4-1
Architecture: any
Multi-Arch: same
Depends: adwaita-icon-theme,
         hicolor-icon-theme,
         shared-mime-info,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common (>= ${source:Version})
Provides: gtk4-binver-4.0.0
Recommends: libgtk-4-bin,
            iso-codes,
            librsvg2-common,
Suggests: gvfs,
Breaks: libgtk-4-0 (<< 4.0.0),
Replaces: libgtk-4-0 (<< 4.0.0),
Pre-Depends: ${misc:Pre-Depends}
Description: GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the shared libraries.

Package: libgtk-4-1-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: gtk4-binver-4.0.0
Description: GTK graphical user interface library - minimal runtime
 This is a udeb, or a microdeb, for the debian-installer.
 .
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the minimal runtime library using X11 needed
 by the Debian installer.

Package: libgtk-4-common
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: libgtk-3-common,
         ${misc:Depends}
Recommends: libgtk-4-1
Description: common files for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the common files which the libraries need.

Package: libgtk-4-bin
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: gtk-update-icon-cache,
         libgtk-3-bin,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common (>= ${source:Version}),
         libgtk-4-1 (>= ${source:Version})
Breaks: gtk-4-examples (<< 3.96.0-3~)
Replaces: gtk-4-examples (<< 3.96.0-3~)
Description: programs for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the utilities which are used by the libraries
 and other packages.

Package: libgtk-4-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: gir1.2-gtk-4.0 (= ${binary:Version}),
         libcairo2-dev (>= 1.14.0),
         libegl1-mesa-dev [linux-any],
         libepoxy-dev (>= 1.0),
         libfontconfig1-dev,
         libgdk-pixbuf-2.0-dev (>= 2.30.0) | libgdk-pixbuf2.0-dev (>= 2.30.0),
         libglib2.0-dev (>= 2.66.0),
         libgraphene-1.0-dev (>= 1.5.1),
         libpango1.0-dev (>= 1.47.0),
         libwayland-dev (>= 1.9.91) [linux-any],
         libx11-dev,
         libxcomposite-dev,
         libxcursor-dev,
         libxdamage-dev,
         libxext-dev,
         libxfixes-dev,
         libxi-dev,
         libxinerama-dev,
         libxkbcommon-dev,
         libxrandr-dev,
         libvulkan-dev [linux-any],
         pkg-config,
         wayland-protocols (>= 1.9) [linux-any],
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common,
         libgtk-4-1 (= ${binary:Version})
Suggests: libgtk-4-doc
Description: development files for the GTK library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the header and development files which are
 needed for building GTK applications.

Package: libgtk-4-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libglib2.0-doc,
            libpango1.0-doc
Suggests: devhelp
Description: documentation for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the HTML documentation for the GTK library
 in /usr/share/doc/libgtk-4-doc/ .

Package: gtk-4-examples
Build-Profiles: <!noinsttest>
Section: x11
Architecture: any
Depends: gtk-3-examples,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-1 (= ${binary:Version})
Recommends: fonts-cantarell,
            librsvg2-common,
Description: example files for GTK 4
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the example files and a demonstration program
 for GTK4. It also contains the installed tests.

Package: gtk-4-tests
Build-Profiles: <!noinsttest>
Section: x11
Architecture: any
Depends: iso-codes,
         librsvg2-common,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-1 (= ${binary:Version}),
Recommends: gnome-desktop-testing,
            locales | locales-all,
Description: "as-installed" tests for GTK 4
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains installable test programs, primarily for use with
 autopkgtest.

Package: gir1.2-gtk-4.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common
Breaks: python-gi (<< 3.18),
        python3-gi (<< 3.18)
Provides: gir1.2-gdk-4.0 (= ${binary:Version}),
          gir1.2-gdkwayland-4.0 (= ${binary:Version}) [linux-any],
          gir1.2-gdkx11-4.0 (= ${binary:Version}),
          gir1.2-gsk-4.0 (= ${binary:Version})
Description: GTK graphical user interface library -- gir bindings
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

#Package: gtk-update-icon-cache
#Section: misc
#Architecture: any
#Multi-Arch: foreign
#Depends: ${misc:Depends},
#         ${shlibs:Depends}
#Breaks: libgtk2.0-bin (<< 2.24.30-2),
#        libgtk-3-bin (<< 3.20.6-1)
#Replaces: libgtk2.0-bin (<< 2.24.30-2),
#          libgtk-3-bin (<< 3.20.6-1)
#Description: icon theme caching utility
# gtk-update-icon-cache creates mmap()able cache files for icon themes.
# .
# GTK can use the cache files created by gtk-update-icon-cache to avoid a lot
# of system call and disk seek overhead when the application starts. Since the
# format of the cache files allows them to be mmap()ed shared between multiple
# applications, the overall memory consumption is reduced as well.

=== debian/rules ===
#!/usr/bin/make -f

DISABLE_UPDATE_UPLOADERS = 1
include /usr/share/gnome-pkg-tools/1/rules/uploaders.mk
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

built_binaries := $(shell dh_listpackages)
all_binaries := $(shell sed -ne 's/^Package: *//p' < debian/control)

# Ensure the build aborts when there are still references to undefined symbols
# currently fails at least in the im-multipress im module
#LDFLAGS += -Wl,-z,defs

# Make the linker work a bit harder so dynamic loading can be done faster
LDFLAGS += -Wl,-O1

APIVER := 4
SONAME := 1

LIBDIR := usr/lib/$(DEB_HOST_MULTIARCH)

# earliest version that this release has backwards binary compatibility for
GTK_BINARY_VERSION := 4.0.0

# Gtk binary version virtual Provide
GTK_BINVER_DEP := gtk$(APIVER)-binver-$(GTK_BINARY_VERSION)

# relative base directory for configuration
CONFDIR := etc/gtk-4.0

# relative base directory for all types of modules
MODULES_BASE_PATH := $(LIBDIR)/gtk-4.0/$(GTK_BINARY_VERSION)

# package names
SHARED_PKG := libgtk-$(APIVER)-$(SONAME)
COMMON_PKG := libgtk-$(APIVER)-common
DEV_PKG := libgtk-$(APIVER)-dev
UDEB_PKG := $(SHARED_PKG)-udeb
DOC_PKG := libgtk-$(APIVER)-doc
BIN_PKG := libgtk-$(APIVER)-bin
EXAMPLES_PKG := gtk-$(APIVER)-examples
TESTS_PKG := gtk-$(APIVER)-tests

# files larger than 4k in size will be compressed by dh_compress
# so append a .gz suffix to avoid dangling symlinks
NEWS := NEWS$(shell find -maxdepth 1 -size +4k -name NEWS -exec echo ".gz" \;)
README.md := README.md$(shell find -maxdepth 1 -size +4k -name README.md -exec echo ".gz" \;)

# macro computing the list of 'debian/<pkg>.*" files which have a
# corresponding ".in" file; pass the list of packages in $(1)
dh_subst_files = $(patsubst %.in,%,$(wildcard $(addprefix debian/, $(addsuffix *.in, $(1)))))

debian/%: debian/%.in
	dh_testdir
	sed \
		-e "s#@SONAME@#$(SONAME)#g" \
		-e "s#@APIVER@#$(APIVER)#g" \
		-e "s#@VERSION@#$(DEB_VERSION_UPSTREAM)#g" \
		-e "s#@GTK_BINVER_DEP@#$(GTK_BINVER_DEP)#g" \
		-e "s#@SHARED_PKG@#$(SHARED_PKG)#g" \
		-e "s#@COMMON_PKG@#$(COMMON_PKG)#g" \
		-e "s#@DEV_PKG@#$(DEV_PKG)#g" \
		-e "s#@UDEB_PKG@#$(UDEB_PKG)#g" \
		-e "s#@DOC_PKG@#$(DOC_PKG)#g" \
		-e "s#@BIN_PKG@#$(BIN_PKG)#g" \
		-e "s#@EXAMPLES_PKG@#$(EXAMPLES_PKG)#g" \
		-e "s#@TESTS_PKG@#$(TESTS_PKG)#g" \
		-e "s#@GNOME_TEAM@#$(UPLOADERS)#g" \
		-e "s#@GTK_BINARY_VERSION@#$(GTK_BINARY_VERSION)#g" \
		-e "s#@LIBDIR@#$(LIBDIR)#g" \
		-e 's#@CONFDIR@#$(CONFDIR)#g' \
		-e "s#@MODULES_BASE_PATH@#$(MODULES_BASE_PATH)#g" \
		-e "s#@NEWS@#$(NEWS)#g" \
		-e "s#@README.md@#$(README.md)#g" \
		$@.in > $@

configure_flags_common = \
	--libdir=/$(LIBDIR) \
	-Dsassc=enabled \
	${NULL}

configure_flags_deb = \
	-Dbroadway-backend=true \
	-Dcloudproviders=disabled \
	-Dintrospection=enabled \
	-Dman-pages=true \
	-Dmedia=none \
	-Dprint-backends=all \
	-Dx11-backend=true \
	-Dxinerama=enabled \
	${NULL}

ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
configure_flags_deb += -Dcolord=enabled
else
configure_flags_deb += -Dcolord=disabled
endif

ifeq (linux,$(DEB_HOST_ARCH_OS))
configure_flags_deb += -Dvulkan=enabled
configure_flags_deb += -Dwayland-backend=true
else
configure_flags_deb += -Dvulkan=disabled
configure_flags_deb += -Dwayland-backend=false
endif

ifeq ($(filter %-doc,$(built_binaries)),)
configure_flags_deb += -Dgtk_doc=false
else
configure_flags_deb += -Dgtk_doc=true
endif

ifeq ($(filter %-examples,$(built_binaries)),)
configure_flags_deb += -Dbuild-examples=false
configure_flags_deb += -Ddemos=false
else
configure_flags_deb += -Dbuild-examples=true
configure_flags_deb += -Ddemos=true
endif

ifeq ($(filter %-tests,$(built_binaries)),)
configure_flags_deb += -Dinstall-tests=false
else
configure_flags_deb += -Dinstall-tests=true
endif

configure_flags_udeb = \
	-Dbroadway-backend=false \
	-Dbuild-examples=false \
	-Dcloudproviders=disabled \
	-Ddemos=false \
	-Dinstall-tests=false \
	-Dwayland-backend=false \
	-Dx11-backend=true \
	-Dxinerama=disabled \
	-Dintrospection=disabled \
	-Dprint-backends=none \
	-Dcolord=disabled \
	-Dmedia=none

%:
	dh $@ --with gir --buildsystem=meson

override_dh_clean: debian/control
	# gross kludge to force control generation with the %.in target
	touch debian/control.in
	rm -f $(call dh_subst_files,$(all_binaries))
	rm -rf debian/build debian/install
	dh_clean

# Add dependencies to generate files from the debian/*.in ones
override_dh_auto_build: $(call dh_subst_files,$(all_binaries))

override_dh_auto_configure: debian/control
	dh_auto_configure \
		--builddirectory=debian/build/deb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_deb) \
		$(NULL)
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_configure \
		--builddirectory=debian/build/udeb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_udeb) \
		$(NULL)
endif

override_dh_auto_build:
	dh_auto_build --builddirectory=debian/build/deb
ifneq ($(filter %-doc,$(built_binaries)),)
	# Explicitly build the documentation: otherwise it's done as a
	# side-effect of the install step, which doesn't respect the
	# dependencies that generate Docbook files from markdown.
	# https://github.com/mesonbuild/meson/issues/1844
	# https://github.com/mesonbuild/meson/issues/5793
	dh_auto_build --builddirectory=debian/build/deb -- gdk4-doc gsk4-doc gtk4-doc
endif
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_build --builddirectory=debian/build/udeb
endif

test_timeout_multiplier = 1

ifneq ($(filter arm hppa mips% sparc%,$(DEB_HOST_ARCH_CPU)),)
$(info Slow architecture detected, increasing test timeout)
test_timeout_multiplier = 10
endif

ifneq ($(filter m68k riscv64 sh4,$(DEB_HOST_ARCH_CPU)),)
$(info Architecture with qemu buildds detected, increasing test timeout a lot)
test_timeout_multiplier = 20
endif

fuzzy_reftests = \
	border-image-url \
	label-attribute-preference \
	label-wrap-justify \
	pseudoclass-on-box \
	quit-mnemonic \
	$(NULL)

xfail_reftests = \
	label-sizing \
	sizegroups-evolution-identity-page \
	$(NULL)

# TODO: Known failures without a bug filed:
# mips(64)el: gtk:gsk+gsk-compare+gsk-opengl+gsk-compare-opengl / opengl blend-normal
#             gtk:gsk+gsk-compare+gsk-opengl+gsk-compare-opengl / opengl blend-difference
#             gtk:gsk+gsk-compare+gsk-broadway+gsk-compare-broadway / broadway blend-normal
#             gtk:gsk+gsk-compare+gsk-broadway+gsk-compare-broadway / broadway blend-difference
# s390x: many (endianness?)
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	rm -f debian/tests-failed
	set -e; for reftest in $(fuzzy_reftests); do \
		cp debian/close-enough.keyfile \
			testsuite/reftests/$$reftest.keyfile; \
	done
	# So that gsettings can find the (uninstalled) gtk schemas
	mkdir -p debian/build/glib-2.0/schemas/
	cp gtk/org.gtk.* debian/build/glib-2.0/schemas/
	glib-compile-schemas debian/build/glib-2.0/schemas/
	# Remove LD_PRELOAD so we don't run with fakeroot, which makes dbus-related tests fail
	env \
		-u LD_PRELOAD \
		GIO_MODULE_DIR=/nonexistent \
		GIO_USE_VFS=local \
		GIO_USE_VOLUME_MONITOR=unix \
	dbus-run-session -- \
	xvfb-run -a -s "-screen 0 1024x768x24" \
	debian/tests/run-with-locales \
		--generate de_DE.UTF-8 \
		--generate en_GB.UTF-8 \
		--generate en_US.UTF-8 \
		--generate sv_SE \
		-- \
	dh_auto_test \
		--no-parallel \
		--builddirectory=debian/build/deb \
		-- \
		--setup=x11 \
		--timeout-multiplier $(test_timeout_multiplier) \
	|| touch debian/tests-failed
	tail -v -n +0 debian/build/deb/meson-logs/testlog-x11.txt
	# Don't base64-encode the image results for tests that upstream
	# expect to fail
	set -e; for reftest in $(xfail_reftests); do \
		rm -f debian/build/deb/testsuite/reftests/output/x11/$$reftest.diff.png; \
	done
	# Put the rest in the log as base64 since we don't have an
	# equivalent of AUTOPKGTEST_ARTIFACTS for buildds
	debian/log-reftests.py
	# Avoid incremental builds with -nc leaking settings into the next build
	set -e; for reftest in $(fuzzy_reftests); do \

=== debian/tests/control ===
Tests: build
Depends: build-essential, libgtk-4-dev, xauth, xvfb
Restrictions: allow-stderr, superficial

Tests: python3-gi
Depends: dbus, gir1.2-gtk-4.0, python3-gi, xauth, xvfb
# https://gitlab.gnome.org/GNOME/pygobject/-/merge_requests/81, !145, etc.
Restrictions: flaky, superficial

Tests: installed-tests
Depends: dbus (>= 1.8), fonts-dejavu-core, gnome-desktop-testing (>= 2018.1-1~), gtk-4-tests, locales | locales-all, ttf-bitstream-vera, xauth, xvfb
Restrictions: allow-stderr

Tests: installed-tests-flaky
Depends: dbus (>= 1.8), fonts-dejavu-core, gnome-desktop-testing (>= 2018.1-1~), gtk-4-tests, locales | locales-all, ttf-bitstream-vera, xauth, xvfb
Restrictions: allow-stderr, flaky

=== debian/watch ===
version=4
https://download.gnome.org/sources/gtk/(\d[\d\.]+)/ \
	gtk-@ANY_VERSION@\.tar\.xz
